Attribute VB_Name = "MUniWindowMsgFilter"
Option Explicit

Public Const UWMF_PROP_NAME_FILTER_OBJ = "punk:CUniWindowMsgFilter"

Private Const WM_NCDESTROY = &H82&

Private Const GWL_WNDPROC = -4&
Private Const GWL_USERDATA = -21&

Private Declare _
    Sub GetMemObj _
    Lib "msvbvm60" ( _
        ByRef pObj As Long, _
        dstVar As Any)

Private Declare _
    Function GetWindowLong _
    Lib "user32" _
    Alias "GetWindowLongA" ( _
        ByVal hwnd As Long, _
        ByVal i As Long _
    ) As Long
    
Private Declare _
    Function GetProp _
    Lib "user32" _
    Alias "GetPropA" ( _
        ByVal hwnd As Long, _
        ByVal lpString As String) As Long
    
Private Declare _
    Function RemoveProp _
    Lib "user32" _
    Alias "RemovePropA" ( _
        ByVal hwnd As Long, _
        ByVal lpString As String) As Long


Public Function UwmfWndProcForOwn(ByVal hwnd&, ByVal msg&, ByVal w&, ByVal l&) As Long
    Dim pFO As Long
    Dim FilterObject As CUniWindowMsgFilter
    On Error GoTo eh
    
    pFO = GetWindowLong(hwnd, GWL_USERDATA)
    
    If pFO = 0 Then Exit Function
    
    GetMemObj pFO, FilterObject
    UwmfWndProcForOwn = FilterObject.WindowProc(msg, w, l)
eh:
End Function

Public Function UwmfWndProcForArb(ByVal hwnd&, ByVal msg&, ByVal w&, ByVal l&) As Long
    Dim pFO As Long
    Dim FilterObject As CUniWindowMsgFilter
    On Error GoTo eh
    
    pFO = GetProp(hwnd, UWMF_PROP_NAME_FILTER_OBJ)
    
    If pFO = 0 Then Exit Function
    
    GetMemObj pFO, FilterObject
    UwmfWndProcForArb = FilterObject.WindowProc(msg, w, l)
eh:
    If msg = WM_NCDESTROY Then
        RemoveProp hwnd, UWMF_PROP_NAME_FILTER_OBJ
    End If
End Function
